#!/usr/bin/perl

########################     KnDolMailer Ver 1.2.1     ########################
###                                                                         ###
###     : 뼮 (kndol@kndol.net)                                    ###
###                                                                         ###
###  ũƮ http://www.CgiMaker.net/ ٿε   ֽϴ. ###
###                                                                         ###
###  ũƮ  ̹ κ Ű Ʈ WeekyMailer    ###
###  Խϴ.                                                          ###
### ̾ƿ Ű Ϸ Ͽϴ.                                ###
### ̹ ̾ƿ   ֵ  ֽ Ű Ʈ        ###
###  帳ϴ.                                                          ###
### Ű Ʈ ּҴ http://weeky.pr.co.kr Դϴ.                      ###
###                                                                         ###
###   ƴ϶    Դϴ.                     ###
###    ̸  ֽø ϰڽϴ.           ###
### ׸,  ̳  ÿ    ֵ ˷ ֽø     ###
###  .                                                          ###
###                                                                         ###
###############################################################################
###                                                                         ###
###            *************************************************            ###
###            *          Fight and Posses the Land!           *            ###
###            *                - Deut 2:24 -                  *            ###
###            *************************************************            ###
###            * Homepage : http://www.kndol.net/              *            ###
###            *          : http://www.CgiMaker.net/           *            ###
###            * e-mail   : kndol@kndol.net                    *            ###
###            *************************************************            ###
###            *                                               *            ###
###            *   ______ __        ________        ______     *            ###
###            *   ___  //_/_______ ___  __ \______ ___  /     *            ###
###            *   __  ,<   __  __ \__  / / /_  __ \__  /      *            ###
###            *   _  /| |  _  / / /_  /_/ / / /_/ /_  /       *            ###
###            *   /_/ |_|  /_/ /_/ /_____/  \____/ /_/        *            ###
###            *                                               *            ###
###            *************************************************            ###
###                                                                         ###
###                                                   2001. 7. 17, KnDol    ###
###                                                                         ###
###############################################################################

$gCgiUrl = $ENV{'SCRIPT_NAME'};
$gCgiVer = "1.2.1";

umask(077);

&getDefaultCfg;
&parseArgument(*FORM);
&readConfig;

if($FORM{'act'} eq "") { &writeMail; }
elsif($FORM{'act'} eq "writeMail") { &writeMail; }
elsif($FORM{'act'} eq "Error") { &Error; }
elsif($FORM{'act'} eq "AttachFile") { &AttachFile; }
elsif($FORM{'act'} eq "sendMail") { &sendMail; }
elsif($FORM{'act'} eq "Admin") { &Admin; }
elsif($FORM{'act'} eq "AdminMode") { &AdminMode; }
elsif($FORM{'act'} eq "saveConfig") { &saveConfig; }
elsif($FORM{'act'} eq "CheckSMTP") { &CheckSMTP; }
else { &writeMail; }

exit;

sub getDefaultCfg {
	if (-e "KnDolMailer.config") {
		require "KnDolMailer.config";
	}

	if ($gMailDir eq "") {
		my($path) = $0;
		$path =~ s/\\/\//g;
		$path =~ s/\/KnDolMailer.cgi$//i;
		$path =~ s/\/KnDolMailer.pl$//i;
		$gMailDir = $path;
	}
	if ($gImageUrl eq "") {
		my($CgiBinUrl) = $gCgiUrl;
		$CgiBinUrl =~ s/KnDolMailer.cgi$//i;
		$CgiBinUrl =~ s/KnDolMailer.pl$//i;
		$gImageUrl = "http://$ENV{'SERVER_NAME'}" . $CgiBinUrl . "images";
	}
	if ($gRootMail eq "") {
		$server = $ENV{'SERVER_NAME'};
		$gRootMail = 'webmaster@' . $server;
	}
	if ($gMaxFileNum eq '' || $gMaxFileNum =~ /\D/) {
		$gMaxFileNum = 7;
	}
}

sub parseArgument {
	local *FORM = shift;
	local($pair,$name,$value,$content_type,$content_length,$buffer,$dump,$boundary,$line,$array_value,$filename);
    local(@pairs,@column);

	if ($ENV{'QUERY_STRING'}) {
		@pairs = split(/&/,$ENV{'QUERY_STRING'});

		foreach $pair (@pairs) {
			($name, $value) = split(/=/,$pair);

			$value =~ tr/+/ /;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

			$FORM{$name} = $value;
		}
	}
	else {
		$content_type = $ENV{'CONTENT_TYPE'};
		$content_length = $ENV{'CONTENT_LENGTH'};

		binmode STDIN;
		read(STDIN,$buffer,$content_length);

		if ((!$content_type) || ($content_type eq 'application/x-www-form-urlencoded')) {
			@pairs = split(/&/, $buffer);

			foreach $pair (@pairs) {
				($name, $value) = split(/=/,$pair);

				$value =~ tr/+/ /;
				$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

				$FORM{$name} = $value;
			}
		}
		elsif ($content_type =~ m#^multipart/form-data#) {
			($boundary = $content_type) =~ s/^.*boundary=(.*)$/\1/;
			@pairs = split(/--$boundary/, $buffer);
			@pairs = splice(@pairs,1,$#pairs-1);

			for $pair (@pairs) {
				($dump,$line,$value) = split(/\r\n/,$pair,3);
				if ($line =~ /filename/) {
					@x = split(/\"/,$line);
					@y = split(/\\/,$x[3]);
					$t = @y;
					$filename = ($y[$t-1]);
					$filename =~ tr/ /+/;
				}
				unless ($line =~ /filename=\"\"/) {
					$line =~ s/^Content-Disposition: form-data; //;
					(@column) = split(/;\s+/, $line);
					($name = $column[0]) =~ s/^name="([^"]+)"$/\1/g;
	
					if ($#column > 0) {
						if ($value =~ /^Content-Type:/) {
							($dump,$dump,$value) = split(/\r\n/,$value,3);
						}
						else {
							($dump,$value) = split(/\r\n/,$value,2);
						}
						$FORM{$name}->{data} = $value;
						$FORM{$name}->{name} = $filename;
						$FORM{$name}->{size} = length($FORM{$name}->{data});
					}
					else {
						($dump,$value) = split(/\r\n/,$value,2);
						if (grep(/^$name$/, keys(%CGI))) {
							if (@{$FORM{$name}} > 0) {
								push(@{$FORM{$name}}, $value);
							}
							else {
								$array_value = $FORM{$name};
								undef $FORM{$name};
								$FORM{$name}[0] = $array_value;
								push(@{$FORM{$name}}, $value);
							}
						}
						else {
							unless ($value =~ /^\s*$/) {
								$FORM{$name} = $value;
								chop($FORM{$name});
								chop($FORM{$name});
							}
						}
					}
				}
			}
		}
		else {
			print "Invalid content type!\n";
			exit(1);
		}
	}
}

sub readConfig {
	my(@data);
	$gConfigFile = ($FORM{'cfg'} ne "") ? "$gMailDir/$FORM{'cfg'}" : "$gMailDir/KnDolMailer.cfg";

	open(HANDLE,"$gConfigFile");
	while(<HANDLE>) {
		next if /^#/;
		chomp;
		($key,$val) = ( /([^=]+)=(.*)/ );
		$key = lc($key);
		$val =~ s|\[(\S+)\]|$vars{$1}|g;
		$val =~ s|\s*$||;
		$gConfigValue{$key} = $val;
	}
	close(HANDLE);
}

sub saveConfig {
	my($cfg) = '';

	if ($FORM{'pass1'} eq "" || $FORM{'pass1'} eq " ") { $FORM{'pass'} = $gConfigValue{'pass'}; }
	elsif ($FORM{'pass1'} ne $FORM{'pass2'}) { &Error("  ȣ Ȯο ȣ  ٸϴ.<br>ٽ ѹ Ȯ ּ."); }
	else { $FORM{'pass'} = &makeCryptPasswd($FORM{'pass1'}); }
	if ($FORM{'align'} eq "") { $FORM{'align'} = $gConfigValue{'align'}; }
	$FORM{'header'} =~ s/\n/\\n/g;
	$FORM{'header'} =~ s/\r//g;
	$FORM{'tail'} =~ s/\n/\\n/g;
	$FORM{'tail'} =~ s/\r//g;

	foreach ('name',
			'email',
			'pass',
			'align',
			'homeurl',
			'bgimage',
			'header',
			'tail',
			'homepage',
			'homename',
			'usemysmtp',
			'sendmail',
			'smtp_server'
		) {
		$cfg .= "$_=$FORM{$_}\n";
	}

	open(HANDLE,">$gConfigFile") || &Error("ȯ  ($gConfigFile)   ϴ.");
	eval "flock HANDLE, 2";
	print HANDLE $cfg;
	close(HANDLE);
	eval "flock HANDLE, 8";

	print "Content-Type: text/html\n\n";
	print "<html><head><META http-equiv=refresh content='0; url=$gCgiUrl?cfg=$FORM{'cfg'}'></head></html>\n";
}

sub writeMail {
	if($gConfigValue{'name'} eq "") {
		&AdminMode;
		exit;
	}

	if ($FORM{'name'} ne "" && $FORM{'mail'} ne "") {
		$gConfigValue{'name'}="$FORM{'name'}";
		$gConfigValue{'email'}="$FORM{'mail'}";
	}

	$gOnLoad = " onLoad=\"document.form.fromname.focus();\"";
	&getCookie;

	my($tastyle) = ($ENV{'HTTP_USER_AGENT'}=~/ MSIE /) ? " style=\"border-color:black; background:rgb(240,255,240) url($gImageUrl/bg-picture.gif) no-repeat fixed right bottom;\""
	                                               : "";

	&header;
	print <<_BODY_;
<div align=$gConfigValue{'align'}><table border="3" cellpadding="4" cellspacing="0" width="560" bordercolordark="#C1E1F9" bordercolorlight="#0B446F">
<tr><form name=form method=post action="$gCgiUrl"><input type=hidden name=act value=AttachFile><input type=hidden name=cfg value=$FORM{'cfg'}><td>
	<table border=0 cellpadding=0 cellspacing=0 width=100%>
		<tr><td height=20 colspan=2 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>
		<tr><td width=222 valign=top rowspan=2>
			<table border=0 cellspacing=0 width=218 height=100>
				<tr><td valign=bottom colspan=2><p><img src=$gImageUrl/from.gif border=0></td></tr>
				<tr><td width=30><p><font size=2≯</font></td>
				<td width=188><p><input type=text name=fromname size=22 style="background-color:rgb(225,255,255);border-color:black;" value="$gCookieName" tabindex="1"></td></tr>
				<tr><td width=30><p><font size=2></font></td>
				<td width=188><p><input type=text name=frommail size=22 style="background-color:rgb(225,255,255);border-color:black;" value="$gCookieMail" tabindex="2"></td>
				</tr>
			</table><br>
			<table border=0 cellspacing=0 width=218 height=100>
				<tr><td valign=bottom colspan=2><p><font size=2><img src=$gImageUrl/to.gif border=0></font></td></tr>
				<tr><td width=30><p><font size=2≯</font></td>
				<td width=188><p><input type=text name=toname size=22 style="color:navy;background-color:rgb(255,255,240);border-color:black;" value="$gConfigValue{'name'}" tabindex="3"></td></tr>
				<tr><td width=30><p><font size=2></font></td>
				<td width=188><p><input type=text name=tomail size=22 style="color:navy;background-color:rgb(255,255,240);border-color:black;" value="$gConfigValue{'email'}" tabindex="4"></td>
				</tr>
			</table><br>
			<table border=0 cellpadding=0 cellspacing=0 width=200>
				<tr><td valign=bottom>
					<FONT size="2">÷ : <SELECT name="FileNum" size="1" style="border:1 solid silver; background:rgb(255,255,240);" tabindex="5">
					<OPTION selected value="0">0</OPTION>
_BODY_
	for (my($i)=1; $i<=$gMaxFileNum; $i++) {
		print "<OPTION value=\"$i\">$i</OPTION>\n";
	}
	print <<_BODY_;
					</SELECT></FONT>
					<br><br><p align=center><a href="$gCgiUrl?act=Admin&cfg=$FORM{'cfg'}" tabindex="9"><img src=$gImageUrl/admin.gif border=0 alt=ڸ></a>
					<a href="http://www.CgiMaker.net/" target=_blank tabindex="10"><font size=2>KnDol's CgiMaker!</font></a></td>
				</tr>
			</table>
		</td>
		<td width=322 valign=top>
			<table border=0 cellpadding=0 cellspacing=0 width=320>
				<tr><td width=206 valign=bottom><p align=left><img src=$gImageUrl/title.gif border=0></td>
				<td width=110 rowspan=3><p align=right><a href="http://www.CgiMaker.net/" target=_blank tabindex="10"><img src=$gImageUrl/stamp.gif border=0></a></td></tr>
				<tr><td width=206><p><input type=text name=title size=27 style="color:black;background-color:rgb(255,238,255);border-color:black;" tabindex="6"></td></tr>
				<tr><td width=206 valign=bottom><p align=left><img src=$gImageUrl/message.gif border=0></td>
				</tr>
			</table>
		<p align=left><textarea name=contents rows=10 cols=42$tastyle tabindex="7"></textarea></td></tr>
		<tr><td width=322 height=40><center><p><input type=image src=$gImageUrl/send.gif border=0 tabindex="8"></center></td></tr>
		<tr><td height=20 colspan=2 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>
	</table>
</td></form></tr>
</table></div>
_BODY_

	&footer;
}

sub AttachFile {
	if($gConfigValue{'name'} eq "") {
		&AdminMode;
		exit;
	}

	&sendMail if ($FORM{'FileNum'} eq "0");

	my($i);

	$gOnLoad = " onLoad=\"document.form.file1.focus();\"";
	&header;

	$FORM{'title'} =~ s/\"/&quot;/g;
	$FORM{'contents'} =~ s/\"/&quot;/g;
	$FORM{'contents'} =~ s/\r\n/<BR>/g;
	$FORM{'contents'} =~ s/\n/<BR>/g;

	print <<_BODY_;
<div align=$gConfigValue{'align'}><table border="3" cellpadding="4" cellspacing="0" width="560" bordercolordark="#C1E1F9" bordercolorlight="#0B446F">
<tr><form name="form" method="post" action="$gCgiUrl" enctype="multipart/form-data">
<input type=hidden name=act value="sendMail">
<input type=hidden name=cfg value="$FORM{'cfg'}">
<input type=hidden name=fromname value="$FORM{'fromname'}">
<input type=hidden name=frommail value="$FORM{'frommail'}">
<input type=hidden name=toname value="$FORM{'toname'}">
<input type=hidden name=tomail value="$FORM{'tomail'}">
<input type=hidden name=title value="$FORM{'title'}">
<input type=hidden name=contents value="$FORM{'contents'}">
<input type=hidden name=FileNum value="$FORM{'FileNum'}">
<td>
	<table border=0 cellpadding=0 cellspacing=0 width=100%>
		<tr><td height=20 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>
		<tr><td valign=center><p align="center"><font size=2><BR>÷  ϼ. ($FORM{'FileNum'} )<BR><BR>
_BODY_
	for ($i=1; $i<=$FORM{'FileNum'}; $i++) {
		print "<INPUT type=\"file\" name=\"file$i\" size=\"50\" style=\"background-color:rgb(225,255,255);border-color:black;\">\n";
	}
	print <<_BODY_;
		<BR><BR><BR>
		<INPUT type=image src=$gImageUrl/send.gif border=0></font></p></td></tr>
		<tr><td height=20 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>
	</table>
</td></form></tr>
</table></div>
_BODY_

	&footer;
}

sub header {
	my($mode) = $_[0];

	$gConfigValue{'header'} =~ s/\\n/\n/g;
	print "Content-Type: text/html\n\n";
	print "<html><head><title>KnDolMailer Ver $gCgiVer";
	print " - $mode" if ($mode ne "");
	print "</title>\n";
	print "<style type=text/css>\n";
	print "<!--\n";
	print "A:link { text-decoration:none;color:blue;}\n";
	print "A:visited { text-decoration:none;color:blue;}\n";
	print "A:active { text-decoration:none;color:blue;}\n";
	print "A:hover { text-decoration:underline;color:red;}\n";
	print "-->\n";
	print "</style></head>\n";
	print "<body bgcolor=white text=black";
	print " background=\"$gConfigValue{'bgimage'}\"" if ($gConfigValue{'bgimage'} ne "");
	print "$gOnLoad>\n";
	print "$gConfigValue{'header'}\n";
}

sub footer {
	$gConfigValue{'tail'} =~ s/\\n/\n/g;
	print "$gConfigValue{'tail'}\n</body></html>";

	exit;
}

sub sendMail {
	my($i, $mailbody, $boundary);

	$fromname = "$FORM{'fromname'}";
	if($FORM{'frommail'} =~ /^.+\@.+(\..+)+/) {
		$frommail = "$FORM{'frommail'}";
		$frommail =~ s/\|/&#124;/g;
	}
	else {
		&Error("   ּҰ Ʋų Է ʾҽϴ.");
	}
	$toname = $FORM{'toname'};
	if($FORM{'tomail'} =~ /^.+\@.+(\..+)+/) {
		$tomail = "$FORM{'tomail'}";
		$tomail =~ s/\|/&#124;/g;
	}
	else {
		&Error("޴   ּҰ Ʋų Է ʾҽϴ.");
	}
	if($FORM{'title'} ne "") {
		$title = $FORM{'title'};
		$title =~ s/\|/&#124;/g;
	}
	else {
		&Error("   Է ʾҽϴ.");
	}

	if($FORM{'contents'} ne "") {
		$contents = $FORM{'contents'};
		$contents =~ s/\|/&#124;/g;
	}
	else {
		&Error("   Է ʾҽϴ.");
	}

	$contents =~ s/\r\n\r\n/<p>/g;
	$contents =~ s/\r\n/<br>/g;
	$contents =~ s/\|/&#124;/g;

	$mailbody = "<html>\n";
	$mailbody .= "<meta http-equiv=Content-Type content=text/html;charset=EUC-KR>\n";
	$mailbody .= "<head><title>KnDolMailer Ver $gCgiVer</title>\n";
	$mailbody .= "<style type=text/css>\n";
	$mailbody .= "<!--\n";
	$mailbody .= "A:link { text-decoration:none; color:blue;}\n";
	$mailbody .= "A:visited { text-decoration:none; color:blue;}\n";
	$mailbody .= "A:active { text-decoration:none; color:blue;}\n";
	$mailbody .= "A:hover { text-decoration:underline; color:red;}\n";
	$mailbody .= "-->\n";
	$mailbody .= "</style>\n";
	$mailbody .= "</head>\n";
	$mailbody .= "<body bgcolor=white text=black>\n";
	$mailbody .= "<div align=left><table border=\"3\" cellpadding=\"4\" cellspacing=\"0\" width=\"560\" bordercolordark=\"#C1E1F9\" bordercolorlight=\"#0B446F\"><tr><td>\n";
	$mailbody .= "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
	$mailbody .= "<tr bgcolor=white><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	$mailbody .= "<tr bgcolor=white><td width=100><p><img src=$gImageUrl/fromed.gif border=0></td>\n";
	$mailbody .= "<td width=334><p><font size=2>$fromname (<a href=mailto:$frommail>$frommail</a>)</font></td>\n";
	$mailbody .= "<td width=110 rowspan=3><p align=right><a href=\"http://www.CgiMaker.net/\" target=_blank><img src=$gImageUrl/stamp.gif border=0></a></td></tr>\n";
	$mailbody .= "<tr bgcolor=white><td width=100><p><font size=2><img src=$gImageUrl/to.gif border=0></font></td>\n";
	$mailbody .= "<td width=334><p><font size=2>$toname (<a href=mailto:$tomail>$tomail</a>)</font></td></tr>\n";
	$mailbody .= "<tr bgcolor=white><td width=100><p align=left><img src=$gImageUrl/title.gif border=0></td>\n";
	$mailbody .= "<td width=334><p><font size=2>$title</font></td></tr>\n";
	$mailbody .= "<tr bgcolor=white><td colspan=3><br><p align=left><img src=$gImageUrl/messaged.gif border=0></p>\n";
	$mailbody .= "<p align=center><table cellpadding=\"7\" cellspacing=\"0\" width=\"520\" style=\"border:1 solid black; background:rgb(240,255,240) url($gImageUrl/bg-picture.gif) no-repeat fixed right bottom;\" align=\"center\"><tr><td align=\"left\">\n";
	$mailbody .= "<font style=\"line-height:140%; font-size: 10pt;\">$contents</font>\n</td></tr></table>\n</p></td></tr>\n";
	$mailbody .= "<tr bgcolor=white><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	$mailbody .= "<tr><td colspan=3><br><p align=center><font size=2 color=red>KnDolMailer Ver $gCgiVer </font><font size=2> </font><a href=\"$gConfigValue{'homepage'}\" target=_blank>\n";
	$mailbody .= "<font size=2>$gConfigValue{'homename'}</font></a></td></tr>\n";
	$mailbody .= "</table></td></tr></table></div>\n";
	$mailbody .= "</body></html>\n";

	$boundary = time;
	$boundary = "------------KnDolMailer_Boundary_$boundary";
	
	if ($gConfigValue{'usemysmtp'} == 1) {
		use KMModules::KnDolSMTP;
		my($sender);

		ref ($sender = new KnDolSMTP({smtp => $gConfigValue{'smtp_server'}}))
 			|| &Error("   ־    ϴ.<br><b>$KnDolSMTP::Error</b><br><br>  Ǹ <a href=\"mailto:$gRootMail\"> </a>  ֽʽÿ.");
 		$sender->OpenMultipart({from => "$fromname <$frommail>", to => "$toname <$tomail>", subject => "$title", subtype => "Mixed", boundary => "$boundary"})
 			|| &Error("   ־    ϴ.<br><b>$KnDolSMTP::Error</b><br><br>  Ǹ <a href=\"mailto:$gRootMail\"> </a>  ֽʽÿ.");
		$sender->Body("EUC-KR", "8bit", "text/html");
		$sender->Send($mailbody);
		for ($i=0; $i<$FORM{'FileNum'}; $i++) {
			my $num = $i + 1;
			$sender->SendFile2({description => "KnDolMailer Attached File #$num", file => $FORM{"file$num"}})
				|| &Error("   ־ ÷    ϴ.<br><b>$sender::Error</b><br><br>  Ǹ <a href=\"mailto:$gRootMail\"> </a>  ֽʽÿ.");
		}
 		$sender->Close();
	}
	else {
		use KMModules::Base64;

		&Error("ȯ  Դϴ.<br><br>  Ǹ <a href=\"mailto:$gConfigValue{'email'}\">$gConfigValue{'name'}</a>Կ  ֽʽÿ.") if ($gConfigValue{'sendmail'} eq "");
		&Error("$gConfigValue{'sendmail'}()   ϴ.<br><br>  Ǹ <a href=\"mailto:$gRootMail\"> </a>  ֽʽÿ.") unless (-e $gConfigValue{'sendmail'});
		open (MAIL, "|$gConfigValue{'sendmail'} -t $tomail") || &Error("$gConfigValue{'sendmail'}()   ϴ.<br><br>  Ǹ <a href=\"mailto:$gRootMail\"> </a>  ֽʽÿ.");
		my($message) = "To: $toname <$tomail>\r\n";
		$message .= "From: $fromname <$frommail>\r\n";
		$message .= "X-Mailer: KnDolMailer $gCgiVer - http://www.CgiMaker.net/\r\n";
		$message .= "Subject: $title\r\n";
		$message .= "Mime-Version: 1.0\r\n";
		$message .= "Content-type: Multipart/mixed; boundary=$boundary\r\n";
		$message .= "This is a multi-part message in MIME format.\r\n\r\n";
		$message .= "\r\n--$boundary\r\n";
		$message .= "Content-type: text/html; charset=EUC-KR\r\n";
		$message .= "Content-description: Mail message body\r\n";
		$message .= "Content-transfer-encoding: 8bit\r\n\r\n";
		$message .= $mailbody;

		for ($i=0; $i<$FORM{'FileNum'}; $i++) {
			my $num = $i + 1;
			my $name = $FORM{"file$num"}->{name};

			$message .= "\r\n--$boundary\r\n";
			$message .= "Content-Type: application/octet-stream; name=\"$name\"\r\n";
			$message .= "Content-description: KnDolMailer Attached File #$num\r\n";
			$message .= "Content-transfer-encoding: Base64\r\n";
			$message .= "Content-disposition: attachment; filename=\"$name\"\r\n\r\n";
			$message .= Base64::encode($FORM{"file$num"}->{data});
		}
		$message .= "\r\n--$boundary--\r\n";
		print MAIL $message;
		close (MAIL);
	}

	print "Set-Cookie: KnDolMailer=$fromname:$frommail; expires=Thu, 31-Dec-2099 00:00:00 GMT\n";

	&header("Transfer Completed!");
	print "<div align=$gConfigValue{'align'}><table border=\"3\" cellpadding=\"4\" cellspacing=\"0\" width=\"560\" bordercolordark=\"#C1E1F9\" bordercolorlight=\"#0B446F\"><tr><td>\n";
	print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
	print "<tr><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	print "<tr><td width=100><p><img src=$gImageUrl/fromed.gif border=0></td>\n";
	print "<td width=334><p><font size=2>$fromname ($frommail)</font></td>\n";
	print "<td width=110 rowspan=3><p align=right><a href=\"http://www.CgiMaker.net/\" target=_blank><img src=$gImageUrl/stamp.gif border=0></a></td></tr>\n";
	print "<tr><td width=100><p><font size=2><img src=$gImageUrl/to.gif border=0></font></td>\n";
	print "<td width=334><p><font size=2>$toname ($tomail)</font></td></tr>\n";
	print "<tr><td width=100><p align=left><img src=$gImageUrl/title.gif border=0></td>\n";
	print "<td width=334><p><font size=2>$title</font></td></tr>\n";
	print "<tr><td colspan=3><br><p align=left><img src=$gImageUrl/messaged.gif border=0></p>\n";
	print "<p align=center><table cellpadding=\"7\" cellspacing=\"0\" width=\"520\" style=\"border:1 solid black; background:rgb(240,255,240) url($gImageUrl/bg-picture.gif) no-repeat fixed right bottom;\" align=\"center\"><tr><td align=\"left\">\n";
	print "<font style=\"line-height:140%; font-size: 10pt;\">$contents</font>\n</td></tr></table>\n</p></td></tr>\n";
	print "<tr><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	print "<tr><td colspan=3><br><p align=center><font size=2>$fromname($frommail) <br>$toname($tomail)Բ ½ϴ.</font></p>\n";
	print "<p align=center><a href=\"$gCgiUrl?cfg=$FORM{'cfg'}\"><font size=2>[   ]</font></a>&nbsp;&nbsp;&nbsp;\n";
	print "<a href=$gConfigValue{'homeurl'}><font size=2>[ Ȩ  ]</font></a>" if ($gConfigValue{'homeurl'} ne "");
	print "</p>\n" ;
	print "<p align=center><font size=2 color=red>KnDolMailer Ver $gCgiVer </font><font size=2> </font><a href=\"http://www.CgiMaker.net/\" target=_blank>\n";
	print "<font size=2>KnDol's CgiMaker!</font></a></td></tr>\n";
	print "</table></td></tr></table></div>\n";
	&footer;
}

sub Error {
	my($errormsg) = $_[0];

	&header("Error!");
	print "<div align=$gConfigValue{'align'}><table border=\"3\" cellpadding=\"4\" cellspacing=\"0\" width=\"560\" bordercolordark=\"#C1E1F9\" bordercolorlight=\"#0B446F\"><tr><td>\n";
	print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
	print "<tr><td background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	print "<tr><td><br><p align=center><font size=3 color=red><b> Error! </b></font></p>\n";
	print "<p align=center><font size=2>$errormsg</font></p>\n";
	print "<p align=center><a href='javascript:history.back()'><font size=2>[ ٽԷ ]</font></a><br><br></td></tr>\n";
	print "<tr><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	print "<tr><td colspan=3><br><p align=center><font size=2 color=red>KnDolMailer Ver $gCgiVer </font><font size=2> </font><a href=\"http://www.CgiMaker.net/\" target=_blank>\n";
	print "<font size=2>KnDol's CgiMaker!</font></a></td></tr>\n";
	print "</table></td></tr></table></div>\n";
	&footer;
	exit;
}

sub Admin {
	$gOnLoad = " onLoad=\"document.form.pass.focus();\"";
	&header(" ");
	print "<form name=form method=post action=\"$gCgiUrl\"><input type=hidden name=act value=AdminMode><input type=hidden name=cfg value=$FORM{'cfg'}>\n";
	print "<div align=$gConfigValue{'align'}><table border=\"3\" cellpadding=\"4\" cellspacing=\"0\" width=\"560\" bordercolordark=\"#C1E1F9\" bordercolorlight=\"#0B446F\"><tr><td>\n";
	print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
	print "<tr><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";

	print "<tr><td colspan=3 align=center><br><p><font size=2 color=blue> йȣ Էϼ.</font></p>\n";
	print "<p><input type=password name=pass size=17 maxlength=8 style=color:black;background-color:rgb(255,238,255);border-color:black;></p></td></tr>\n";
	print "<tr><td height=60 align=right width=260><input type=image src=$gImageUrl/ok.gif border=0></td><td width=24><p>&nbsp;</td>\n";
	print "<td align=left width=260><a href=\"$gCgiUrl\"><img src=$gImageUrl/cancel.gif border=0></a></td></tr>\n";
	print "<tr><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	print "<tr><td colspan=3><br><p align=center><font size=2 color=red>KnDolMailer Ver $gCgiVer </font><font size=2> </font><a href=\"http://www.CgiMaker.net/\" target=_blank>\n";
	print "<font size=2>KnDol's CgiMaker!</font></a></td></tr>\n";
	print "</form></table></td></tr></table></div>\n";
	&footer;
}

sub AdminMode {
	if ($gConfigValue{'pass'} && !(&checkPasswd($gConfigValue{'pass'}, $FORM{'pass'}))) {
		&Error(" йȣ Ʋϴ.");
	}

	$gConfigValue{'header'} =~ s/\\n/\n/g;
	$gConfigValue{'tail'} =~ s/\\n/\n/g;

	&header(" ");
	print "<form method=post action=\"$gCgiUrl\" name=\"form\"><input type=hidden name=act value=saveConfig><input type=hidden name=cfg value=$FORM{'cfg'}>\n";
	print "<div align=$gConfigValue{'align'}><table border=\"3\" cellpadding=\"4\" cellspacing=\"0\" width=\"560\" bordercolordark=\"#C1E1F9\" bordercolorlight=\"#0B446F\"><tr><td>\n";
	print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
	print "<tr><td background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	print "<tr><td><br><div align=center><table border=1 cellpadding=7 cellspacing=0 width=460 bordercolor=black><tr><td bgcolor=gray>\n";
	print "<p align=center><font size=2 color=white><b>KnDolMailer Ver $gCgiVer -  </b></font></td></tr></table></div><br>\n";
	if($gConfigValue{'name'} eq "") {
		print "<p align=center><font size=2 color=red><b>ġ ϼ̱. Ʒ    Է ּ.</b></font></p>\n";
		$gConfigValue{'usemysmtp'} = 1;
		$gConfigValue{'sendmail'} = "/usr/sbin/sendmail";
	}
	print "<div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr colspan=4><td width=100><p align=center><font size=2>йȣ </font></td>\n";
	print "<td width=130 align=center><p><input type=password name=pass1 size=17 maxlength=8 style=\"color:black;background-color:rgb(255,238,255);border-color:black;\"></td>\n";
	print "<td width=100><p align=center><font size=2>ٽԷ</font></td>\n";
	print "<td width=130 align=center><p><input type=password name=pass2 size=17 maxlength=8 style=\"color:black;background-color:rgb(255,238,255);border-color:black;\"></td></tr>\n";
	print "<tr><td width=100><p align=center><font size=2> ̸</font></td>\n";
	print "<td width=130 align=center><p><input type=text name=name size=17 style=\"background-color:rgb(225,255,255);border-color:black;\" value=\"$gConfigValue{'name'}\"></td>\n";
	print "<td width=100><p align=center><font size=2>ڸ</font></td>\n";
	print "<td width=130 align=center><p><input type=text name=email size=17 style=\"background-color:rgb(225,255,255);border-color:black;\" value=\"$gConfigValue{'email'}\"></td></tr>\n";
	print "<tr><td width=100><p>&nbsp;</td><td width=130><p>&nbsp;</td><td width=100><p>&nbsp;</td><td width=130><p>&nbsp;</td></tr></table></div>\n";

	print "<div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr><td bgcolor=#C0FFC0><p align=center><font size=2 color=blue>   ʿ Ȩ  </font></td></tr></table></div>\n";

	print "<br><div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr><td width=120><p align=center><font size=2>Ȩ URL</font></td>\n";
	print "<td><p><input type=text name=homepage size=50 style=\"color:navy;background-color:rgb(255,240,255);border-color:black;\" value=\"$gConfigValue{'homepage'}\"></td></tr>\n";
	print "<tr><td width=120><p align=center><font size=2>Ȩ ̸</font></td>\n";
	print "<td><p><input type=text name=homename size=50 style=\"color:navy;background-color:rgb(240,255,255);border-color:black;\" value=\"$gConfigValue{'homename'}\"></td></tr>\n";
	print "</table></div>\n";

	print "<br><div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr><td bgcolor=#C0FFC0><p align=center><font size=2 color=blue>KnDolMailer ġ   </font></td></tr></table></div>\n";

	print "<br><div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr><td width=100><p align=center><font size=2>Ϸ </font></td>\n";
	if($gConfigValue{'align'} eq "left") {
		print "<td width=120><p><input type=radio name=align value=left checked><font size=2> </font></td>\n";
	}
	else {
		print "<td width=120><p><input type=radio name=align value=left><font size=2> </font></td>\n";
	}
	if($gConfigValue{'align'} eq "center") {
		print "<td width=120><p><input type=radio name=align value=center checked><font size=2> </font></td>\n";
	}
	else {
		print "<td width=120><p><input type=radio name=align value=center><font size=2> </font></td>\n";
	}
	if($gConfigValue{'align'} eq "right") {
		print "<td width=120><p><input type=radio name=align value=right checked><font size=2> </font></td></tr>\n";
	}
	else {
		print "<td width=120><p><input type=radio name=align value=right><font size=2> </font></td></tr>\n";
	}
	print "<tr><td width=100><p align=center><font size=2>Ȩư URL</font></td>\n";
	print "<td colspan=3 width=360><p><input type=text name=homeurl size=50 style=color:navy;background-color:rgb(255,255,240);border-color:black; value=\"$gConfigValue{'homeurl'}\"></td></tr>\n";
	print "<tr><td width=100><p align=center><font size=2>׸</font></td>\n";
	print "<td colspan=3 width=360><p><input type=text name=bgimage size=50 style=color:navy;background-color:rgb(240,255,240);border-color:black; value=\"$gConfigValue{'bgimage'}\"></td></tr>\n";
	print "</table></div>\n";
	print "<br><div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr><td width=50%><p align=center><font size=2>BODY պκ</font></td>\n";
	print "<td width=50%><p align=center><font size=2>BODY ޺κ</font></td></tr>\n";
	print "<tr><td width=50%><p align=center><font size=2><textarea name=header rows=5 cols=30 style=\"border-color:black; background:rgb(240,255,250);\">$gConfigValue{'header'}</textarea></font></td>\n";
	print "<td width=50%><p align=center><font size=2><textarea name=tail rows=5 cols=30 style=\"border-color:black; background:rgb(240,250,255);\">$gConfigValue{'tail'}</textarea></font></td></tr>\n";
	print "</table></div>\n";

	print "<br><div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr><td bgcolor=#C0FFC0><p align=center><font size=2 color=blue>Sendmail   </font></td></tr></table></div>\n";

	print "<br><div align=center><table border=0 cellpadding=3 cellspacing=0 width=460>\n";
	print "<tr><td width=100><p align=center><font size=2>  </font></td>\n";

	$sel = ($gConfigValue{'usemysmtp'} == 1) ? "<option value=1 selected></option><option value=0> </option>"
	                                : "<option value=1></option><option value=0 selected> </option>";

	print "<td><select name=usemysmtp style=\"border:1 solid siver; background:rgb(255,255,240);\">$sel</select><font size=2> &nbsp;&nbsp;&nbsp;&nbsp;( ҽ sendmail )</font></td></tr>\n";

	print "<tr><td width=100><p align=center><font size=2>SMTP </font></td>\n";
	print "<td><input type=text name=smtp_server size=38 style=\"color:navy;background-color:rgb(240,255,255);border-color:black;\" value=\"$gConfigValue{'smtp_server'}\"> &nbsp;<input type=\"button\" value=\"˻\" onClick=\"CheckSMTP(this.form.smtp_server.value, this.form.name.value, this.form.email.value);\" style=\"background-color:#FFE29D;border:2 solid black;height:20\"></td></tr>\n";
	print "<tr><td width=100><p align=center><font size=2>Sendmail </font></td>\n";
	print "<td><input type=text name=sendmail size=46 style=\"color:navy;background-color:rgb(240,255,255);border-color:black;\" value=\"$gConfigValue{'sendmail'}\"></td></tr>\n";
	print "<tr><td colspan=2><p><font size=2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   ɼǿ   о⸦ ϼ.<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; SMTP    Ȯϱ  '˻' ư .</font></p></td></tr>\n";
	print "</table></div>\n";
	print "</td></tr><tr><td height=50 align=center><p><input type=image src=$gImageUrl/save.gif border=0></td></tr>\n";
	print "<tr><td colspan=3 background=$gImageUrl/line.gif><p>&nbsp;</td></tr>\n";
	print "<tr><td colspan=3><br><p align=center><font size=2 color=red>KnDolMailer Ver $gCgiVer </font><font size=2> </font><a href=\"http://www.CgiMaker.net/\" target=_blank>\n";
	print "<font size=2>KnDol's CgiMaker!</font></a></td></tr>\n";
	print "</form></table></td></tr></table></div>\n";
	print <<_JS_;
<script language=javascript>
<!--
	function CheckSMTP(smtp, name, email) {
		msgWindow=window.open('$gCgiUrl?act=CheckSMTP&smtp=' + smtp + '&name=' + name + '&email=' + email,'CheckSMTP','statusbar=no,scrollbars=no,status=yes,resizable=yes,width=400,height=150');
	}
// -->
</script>
_JS_
	&footer;
}


sub CheckSMTP {
	use KMModules::KnDolSMTP;
	my($sender, $open);

	$FORM{'smtp'} = ($FORM{'smtp'} ne '') ? $FORM{'smtp'} : "localhost";

	&header("SMTP  Ȯ - $FORM{'smtp'}");
	
	print "<div align=\"center\"><font size=\"+1\"><b>SMTP  Ȯ</b></font></div><br>\n";
	print "<ol style=\"margin-left: 30pt;\"><li>: <b>$FORM{'smtp'}</b></li>\n<li>  : <b>";
	ref ($sender = new KnDolSMTP({smtp => $FORM{'smtp'}}));
	$open = $sender->Check({from => "$FORM{'name'} <$FORM{'email'}>"}) unless ($sender < 0);
	unless ($sender < 0 || $open < 0) {
		print "</b>";
	}
	else {
		print "</b><br>$KnDolSMTP::Error";
	}
	print "</li></ol>\n";
	$sender->Close();
	&footer;
}

sub getCookie {
    my($cookie, $value);

	foreach (split(/; /, $ENV{'HTTP_COOKIE'})) {
		($cookie, $value) = split(/=/);
		($gCookieName, $gCookieMail)  = split(/:/, $value)  if ($cookie eq "KnDolMailer");
	}
}

###############################################################################
sub makeCryptPasswd {
	my(@saltset) = ('a' .. 'z' , 'A' .. 'Z' , '0' .. '9' , '.' , '/');
	my($salt) = "$saltset[int(rand(64))]$saltset[int(rand(64))]";
	return crypt($_[0], $salt);
}

###############################################################################
sub checkPasswd {
	my($cryptpass) = crypt($_[1], substr($_[0], 0, 2));
	if ($_[0] eq $cryptpass) {
		return 1;
	}
	return 0;
}